/*
 * File: ListPermutations.java
 * ---------------------------
 * This program lists the permutations of a string.
 */

import acm.program.*;

public class ListPermutations extends ConsoleProgram {

/* Standard entry point */
	public static void main(String[] args) {
		new ListPermutations().start(args);
	}

/* Program entry point */
	public void run() {
		while (true) {
			print("Enter a string: ");
			String str = readLine();
			if (str.length() == 0) break;
			listPermutations(str);
		}
	}

/* Method: listPermutations(str) */
/**
 * Lists the permutations of the specified string.
 */
	public void listPermutations(String str) {
		listPermutations("", str);
	}

/* Private method: listPermutations(prefix, str) */
/**
 * Lists the strings that can be formed by starting with
 * prefix and then appending all permutations of str.
 */
	private void listPermutations(String prefix, String str) {
		if (str.length() == 0) {
			println(prefix);
		} else {
			for (int i = 0; i < str.length(); i++) {
				char ch = str.charAt(i);
				String rest = str.substring(0, i) + str.substring(i + 1);
				listPermutations(prefix + ch, rest);
			}
		}
	}
}
